<template>
    <!-- search and profile component -->

    <v-row class="mx-6 mt-n2 d-flex flex-row justify-space-between">
        <SearchComponent />
        <profileComponent :fname="fname" @update-fname="updateFname" />
        <!-- <editComp @update-fname="updateFname" /> -->


    </v-row>

    <!-- Cloud storage-dashboard component -->
    <v-col>
        <div class="cloud-services">

            <dashboardstorageComponent v-for="(cloud, index) in storageData" :key="index" :service-name="cloud.name"
                :space-used="cloud.spaceUsed" :total-space="cloud.totalSpace"
                :completion-percentage="cloud.completionPercentage" :icon="cloud.icon" :icon-color="cloud.iconColor"
                :bg="index % 2 === 0" />
        </div>
    </v-col>

    <!-- quickAcces and Data table Component. -->
    <v-col cols="12" class="mt-n4">
        <quickAccesComponent @addQuickAccessItem="addItemToQuickAccess" :title="'Quick Access'" :items="quickAccessItems" />
    </v-col>
    <v-col cols="12" class="mt-n4">
        <filedataTableComponent />
    </v-col>

    <!-- navigation-drawer -->
    <v-navigation-drawer class="ml-4 rounded-ts-xl" width="320" v-model="drawer" :rail="rail" permanent location="right"
        @click="rail = false">

        <!-- navigation-drawer action -->
        <v-row class="pa-2 mt-4 ml-4">
            <v-col v-if="!rail" class="d-flex align-center">
                <p class="text-h6 text-md-h5 text-lg-h4 font-weight-black">Dropbox</p>
            </v-col>
            <v-col class="d-flex  justify-end">

                <v-btn v-if="!rail" variant="text" icon="mdi-chevron-right" @click.stop="rail = !rail"></v-btn>
                <v-btn v-else variant="text" icon="mdi-chevron-left" @click.stop="rail = !rail"></v-btn>

            </v-col>
        </v-row>
        <!-- TimelineComponent in navigation-drawer -->
        <v-row v-if="!rail">
            <TimelineComponent />
        </v-row>
    </v-navigation-drawer>
</template>
<script>

import SearchComponent from './searchComponent.vue';
import TimelineComponent from './timeLineComponent.vue';
import dashboardstorageComponent from './dashboardstorageComponent.vue';
import quickAccesComponent from './quickAccesComponent.vue';
import filedataTableComponent from './filedataTableComponent.vue';
import profileComponent from './profileComponent.vue';

definePageMeta({
    middleware: "auth-khan"

})
export default {
    data() {
        return {
            drawer: true,
            rail: false,
            storageData: [
                {
                    name: "Drop Box",
                    spaceUsed: 50,
                    totalSpace: 128,
                    completionPercentage: 56,
                    icon: "mdi mdi-dropbox",
                    iconColor: "#007ee5"
                },
                {
                    name: "Google Drive",
                    spaceUsed: 83,
                    totalSpace: 512,
                    completionPercentage: 11,
                    icon: "mdi mdi-google-drive",
                    iconColor: "#007ee5"
                },
                {
                    name: "One Cloud",
                    spaceUsed: 124,
                    totalSpace: 265,
                    completionPercentage: 62,
                    icon: "mdi mdi-cloud",
                    iconColor: "#007ee5"
                },

            ],
            quickAccessItems: [
                { icon: "mdi mdi-image", text: "Images", iconColor: "purple-icon" },
                { icon: "mdi mdi-play-box", text: "Play", iconColor: "red-icon" },
                { icon: "mdi mdi-music-box", text: "Music", iconColor: "orange-icon" },
                { icon: "mdi mdi-apps", text: "Apps", iconColor: "blue-icon" },
                { icon: "mdi mdi-zip-box", text: "Zip", iconColor: "gray-icon" },
                { icon: "mdi mdi-file-document", text: "Docs", iconColor: "blue-icon" },
                { icon: "mdi mdi-download-box", text: "Downloads", iconColor: "green-icon" },


            ],
        }
    },
    components: {
        SearchComponent,
        TimelineComponent,
        dashboardstorageComponent,
        quickAccesComponent,
        filedataTableComponent,
        profileComponent,

    },
    methods: {
        // add QuickAccess Item
        addItemToQuickAccess(newItem) {
            this.quickAccessItems.push(newItem);
            console.log('Added new item:', newItem);
        }
    }

}
</script>

<style scoped>
.cloud-services {
    display: flex;
    justify-content: space-around;
    flex-wrap: wrap;
}
</style>